require 'settingslogic'
require 'fileutils'

USER_CONF_LOCATION = "#{ENV['HOME']}/.deck.d"
DEFAULT_CONF_LOCATION = ['/etc/deck', USER_CONF_LOCATION]

class Deck::Config < Settingslogic
  DEFAULT_CONF_LOCATION.each do |location|
    source "#{location}/config.yml"
  end
end

if Deck::Config['dir'].nil?
  Deck::Config['dir'] = USER_CONF_LOCATION
else
  Deck::Config.source "#{Deck::Config.dir}/config.yml"
end

def ensure_user_config
  FileUtils.mkdir_p USER_CONF_LOCATION
end
