class Deck::Container::Archive
  include Deck::Submodule
  include Deck::Repeatable

  repeatable true
  register_name :archive

  def define(file, path: '/', type: :tar)
    step do
      attributes[:file] = file
      attributes[:path] = path
      attributes[:type] = type
    end
  end

  def export
    attributes[:file]
  end

  def build_command(deps)
    cmd = "ADD #{attributes[:file]} #{attributes[:path]}\n"
    cmd += "RUN #{send attributes[:type]}"
  end

  def tar
    "cd #{attributes[:path]} && tar xf #{filename}"
  end

  def tar_gz
    "cd #{attributes[:path]} && tar zxf #{filename}"
  end

  def zip
    "cd #{attributes[:path]} && unzip #{filename}"
  end

  def filename
    File.basename attributes[:file]
  end
end
