class Deck::Container::Env
  include Deck::Submodule
  include Deck::Repeatable

  register_name :env
  repeatable true

  def initialize
  end

  def define(name, value)
    step do
      attributes[:name] = name
      attributes[:value] = value
    end
  end

  def export
    {attributes[:name].to_sym => attributes[:value]}
  end

  def build_command(deps)
    "ENV #{attributes[:name]} #{attributes[:value]}"
  end
end
