class Deck::Container::From
  include Deck::Submodule

  register_name :from
  dependancies :repository

  def define(name, of: nil)
    attributes[:name] = name
    attributes[:repository] = of
  end

  def export
    attributes[:name]
  end

  def build_command(deps)
    repository = attributes[:repository]
    repository = deps[:repository].get if repository.nil?
    "FROM #{repository}/#{export}"
  end
end
