class Deck::Container::Variable
  include Deck::Submodule

  register_name :variable
  type :meta

  def initialize
    @variables = {}
  end

  def define(name, value)
    @variables[name.to_sym] = value
  end

  def prepare
    Hash[*@variables.map { |k,v| [k, "::#{k}::"]}.flatten].dup.freeze
  end

  def process(command)
    @variables.each do |k,v|
      command.gsub! "::#{k}::", v.to_s
    end

    command
  end

  def meta
    @variables.dup.freeze
  end
end
