module Deck::Submodule
  def map
    {
        build: {
            set: :define,
            get: :export
        },
        meta: {
            set: :define,
            get: :prepare
        }
    }
  end

  def attributes
    @attributes ||= {}
    @attributes
  end

  def value
    attributes
  end

  def set(*args)
    method = map[self.class.type][:set]
    public_send method, *args if respond_to? method
  end

  def get
    method = map[self.class.type][:get]
    public_send method if respond_to? method
  end

  def build_command(deps)
  end

  module ClassMethods
    def meta?
      type == :meta
    end

    def repeatable?
      @repeatable
    end

    def type(type=nil)
      @type ||= :build
      @type = type unless type.nil?
      @type
    end

    def repeatable(value=nil)
      @repeatable = value unless type.nil?
      @repeatable
    end

    def register_name(name=nil)
      @name = name unless name.nil?
      @name
    end

    def dependancies(dependancies=nil)
      unless dependancies.nil?
        dep_list = dependancies
        dep_list = [dependancies] unless dependancies.instance_of? Array
        @dependancies = dep_list
      end
      @dependancies
    end
  end

  def self.included(target)
    target.extend ClassMethods
  end
end
